/*
	Query - Pings X36 driver.

	Based on Query.c - 1998 James M. Finnegan - Microsoft Systems Journal

*/
#include <windows.h>
#include <stdio.h>

void main(int argc, char *argv[])
{
    char buffer[65535];    
    char szName[256];
	unsigned long j,k = 0;
    int i=0;
	HANDLE hDriver, hInput;

    printf("X36 Device Test Program\n");

	if (argc != 2)
	{
		printf("Usage: query profile.bpf\n");
		return;
	}
    
    sprintf(szName,"\\\\.\\%s", "X36Program");

	hInput = CreateFile(argv[1],
							GENERIC_READ,
							FILE_SHARE_READ,
							0,
							OPEN_EXISTING,
							0,
							0);

	if(hInput == INVALID_HANDLE_VALUE)
	{	printf("Error: unable to open file %s.   Error %ld\n", argv[1],GetLastError());
		printf("Usage: query profile.bpf\n");
		return;
	}
	

    hDriver = CreateFile(szName,
                     GENERIC_READ | GENERIC_WRITE, 
                     FILE_SHARE_READ | FILE_SHARE_WRITE,
                     0,                     // Default security
                     OPEN_EXISTING,
                     0,  
                     0);                    // No template

    // If the open failed, print out the error code
    if(hDriver == INVALID_HANDLE_VALUE)
	{
        printf("Error opening driver.  Error: %ld\n",
               GetLastError());
		CloseHandle(hInput);
	}
    else
    {	
		// Ping driver.
		buffer[0]=0;
		WriteFile(hDriver,buffer,1,&j,NULL);

		buffer[0]=1;
		ReadFile(hDriver,buffer,1,&j,NULL);
		if ((j != 1) || buffer[0] != 0)
		{
			printf("Ping error.  Value: %d\n",buffer[0]);
			CloseHandle(hDriver);
			CloseHandle(hInput);
			return;
		}
		else
			printf("Ping complete.\n");


		// Driver responding.  Configure to load profile.
		buffer[0]=1;
		WriteFile(hDriver,buffer,1,&j,NULL);
		buffer[0]=1;
		ReadFile(hDriver,buffer,1,&j,NULL);
		if ((j != 1) || buffer[0] != 0)
		{
			printf("Error setting up profile load.  Value: %d\n",buffer[0]);
			CloseHandle(hDriver);
			CloseHandle(hInput);
			return;
		}
		else
			printf("Driver open complete.\n");


		ReadFile(hInput,buffer, 65535, &k, NULL);
		if (!j)
		{
			printf("Error reading file.  Value: %d\n",GetLastError());
			CloseHandle(hDriver);
			CloseHandle(hInput);
			return;
		}
		else
			printf("File read complete.  Read %d bytes.\n",k);


		WriteFile(hDriver,buffer,k,&j,NULL);
		printf("Profile send complete.  Sent %d bytes.\n",j);

		ReadFile(hDriver,buffer,1,&j,NULL);
		if ((j != 1) || buffer[0] != 0)
		{
			printf("Profile load error.  Value: %d\n",buffer[0]);

		}
		else
			printf("Profile load complete.\n");


        CloseHandle(hDriver);
		CloseHandle(hInput);
	}
}
